#include <stdlib.h>
#include <string.h>

/*
 * Fixes for testing program "test12.py":
 * 
 * Change line 33 to:
 * obj = "./" + filename[:-2] + ".so"
 * Because "apt" doesn't have Python with method named "removesuffix" (Newest version I get is 3.6.5)
 * 
 * Change line 40 to:
 * entry = lambda p: lib.entry(p.encode ("ASCII"))
 * Without applying change, strlen doesn't function as documented, returning only 1
 */

/*
 * #define INCLUDE_MAIN
 * #define DEBUG
 */

//Only import when program needs it
#if defined (INCLUDE_MAIN) || defined (DEBUG)
#include <stdio.h>
#endif

#ifdef DEBUG

void print_prog (int *expr, int size)
{
    for (int i = 0; i < size; i++)
    {
        //Print character for operator
        if (i % 2 == 1)
        {
            printf ("%c", expr[i]);
        }
        //Print number
        else
        {
            printf ("%d", expr[i]);
        }
    }
    //Print end of line
    printf ("\n");
}

#endif // DEBUG

int entry (char *prog)
{
    int size = strlen (prog);

    int *expr = malloc (sizeof (int) * size);
    //Use 2 for loop instead of 1 so don't have to check modulo to know if number or operator
    for (int i = 0; i < size; i += 2)
    {
        expr[i] = prog[i] - '0'; //Change from graphical character to corresponding number
    }
    for (int i = 1; i < size; i += 2)
    {
        expr[i] = prog[i];
    }

    while (size > 1)
    {
        #ifdef DEBUG
        print_prog (expr, size);
        #endif // DEBUG

        //Find operation to calculate now
        int oper = size - 2;
        int oper_symbol = expr[oper];
        for (int i = size - 4; i > 0; i -= 2)
        {
            int current_oper_symbol = expr[i]; //Cache it
            if (oper_symbol == '+' || oper_symbol == '-' || current_oper_symbol == '*' || current_oper_symbol == '/')
            {
                oper = i;
                oper_symbol = current_oper_symbol;
            }
        }

        //printf ("位置 %d 字 %c\n",oper,(char)oper_symbol);

        int a = expr[oper - 1];
        int b = expr[oper + 1];
        //int result; no longer need it

        switch (oper_symbol)
        {
        case '+':
            a += b; //Modify "a" instead of using "resutl" variable. Clever! ;)
            break;
        case '-':
            a -= b;
            break;
        case '*':
            a *= b;
            break;
        case '/':
            a /= b;
            break;
        }

        expr[oper - 1] = a;

        //Move everything back for there to be no gap
        for (int i = oper; i < size - 1; i++)
        {
            expr[i] = expr[i + 2];
        }
        //Expression has undergone shrinking, so update "size" to match
        size -= 2;
    }

    return expr[0];
}

#ifdef INCLUDE_MAIN

int main (int argc, char **argv)
{
    if (argc < 2)
    {
        printf ("Please provide expression to calculate");
        return 1;
    }

    printf ("%d\n", entry (argv[1]));
    return 0;
}

#endif // INCLUDE_MAIN
